function h  = homography( xl,yl,xr,yr ,hl,wl,hr,wr )
 
 Tl= [1/hl, 0 , -0.5;
     0,      1/wl, -0.5;
     0 , 0, 1;];
 
 Tr= [1/hr, 0 , -0.5;
     0,      1/wr, -0.5;
     0 , 0, 1;]; 
 xlp=[xl yl];
 xrp=[xr yr];
  [xl,yl]= scaleAndTranslate(xl,yl,hl,wl,0.5,0.5);
 [xr,yr]= scaleAndTranslate(xr,yr,hr,wr,0.5,0.5);
  
A=zeros(8,9);

for i=1:4
        A((i-1)*2+1,:)= [-xr(i),-yr(i),-1, 0 ,0 , 0, xl(i)*xr(i),yr(i)*xl(i), xl(i)];   
    
end


 for i=1:4
        A((i)*2,:)= [ 0 ,0 , 0,-xr(i),-yr(i),-1, xr(i)*yl(i),yr(i)*yl(i), yl(i)];   
    
 end
 

 [U,S,V] =svd(A);
 
 h = V(:, end);

 h=reshape(h,3,3);
  h=h';

 h=inv(Tl)*h*Tr;
 
 end

