%auto homography
clear all
clc 
close all
H=zeros(3,3,3);

name=[161629;161632;161635;161640];


for i=1:3
    fn1=sprintf('IMG_20141125_%d.jpg',name(i));
    fn2=sprintf('IMG_20141125_%d.jpg',name(i+1));
L=imresize(imread(fn1),1);
R=imresize(imread(fn2),1);

 l=rgb2gray(L);
  r=rgb2gray(R);
  [hl wl n]=size(l);
  [hr wr n]=size(r);
  pointsL = detectSURFFeatures(l,'MetricThreshold',1000);
  pointsR = detectSURFFeatures(r,'MetricThreshold',1000);
  
  [featuresL,validPointsL] = extractFeatures(l,pointsL);
  [featuresR,validPointsR] = extractFeatures(r,pointsR);
  
  indexPairs = matchFeatures(featuresL,featuresR);
  
  matchedL  = validPointsL(indexPairs(:,1));
matchedR = validPointsR(indexPairs(:,2));


locL=matchedL.('Location');

locR=matchedR.('Location');

  h=ransac(locL,locR,hl,wl,hr,wr, 1000,0.99,10);
  
  H(:,:,i)=h;
end
 
H(:,:,3)=H(:,:,3)'*H(:,:,2)'*H(:,:,1)';
H(:,:,2)=H(:,:,2)'*H(:,:,1)';
H(:,:,1)=H(:,:,1)';
%%
fn1=sprintf('IMG_20141125_%d.jpg',name(1));
L=imresize(imread(fn1),1);
 
T = maketform('projective',H(:,:,3));
 [b,xdata,ydata]=imtransform(R,T);
  xMax=round(xdata(2))+10;
% xMax=9000;
prevEnd=size(L,2);
for i=1:3
    
    fn2=sprintf('IMG_20141125_%d.jpg',name(i+1));


R=imresize(imread(fn2),1);
  T = maketform('projective',H(:,:,i));
 [b,xdata,ydata]=imtransform(R,T);

 xdataout=[1 xMax];
ydataout=[1 500];
% let's transform both images with the computed xdata and ydata
rT=imtransform(R,T,'XData',xdataout,'YData',ydataout);
lT=imtransform(L,maketform('affine',eye(3)),'XData',xdataout,'YData',ydataout);
 
 L= alpha(lT,rT,xdata,prevEnd);
 prevEnd=xdata(2);
 imshow(L);
end