%auto homography
clear all
clc 
close all
H=zeros(3,3,3);

name=[132524;132529;132532;132535];


for i=1:3
    fn1=sprintf('IMG_20141125_%d.jpg',name(i));
    fn2=sprintf('IMG_20141125_%d.jpg',name(i+1));
L=imresize(imread(fn1),0.5);
R=imresize(imread(fn2),0.5);

 l=rgb2gray(L);
  r=rgb2gray(R);
  [hl wl n]=size(l);
  [hr wr n]=size(r);

  imshow(l);
  [xl,yl]=ginput(4);
  
  imshow(r);
  [xr,yr]=ginput(4);
  
  h=homography( xl,yl,xr,yr ,hl,wl,hr,wr );
  H(:,:,i)=h;
end
 
H(:,:,3)=H(:,:,3)'*H(:,:,2)'*H(:,:,1)';
H(:,:,2)=H(:,:,2)'*H(:,:,1)';
H(:,:,1)=H(:,:,1)';
%%
fn1=sprintf('IMG_20141125_%d.jpg',name(1));
L=imresize(imread(fn1),0.5);
 
T = maketform('projective',H(:,:,3));
 [b,xdata,ydata]=imtransform(R,T);
  xMax=round(xdata(2))+10;
% xMax=9000;
prevEnd=size(L,2);
for i=1:3
    
    fn2=sprintf('IMG_20141125_%d.jpg',name(i+1));


R=imresize(imread(fn2),0.5);
  T = maketform('projective',H(:,:,i));
 [b,xdata,ydata]=imtransform(R,T);

 xdataout=[1 xMax];
ydataout=[1 500];
% let's transform both images with the computed xdata and ydata
rT=imtransform(R,T,'XData',xdataout,'YData',ydataout);
lT=imtransform(L,maketform('affine',eye(3)),'XData',xdataout,'YData',ydataout);
 
 L= alpha(lT,rT,xdata,prevEnd);
 prevEnd=xdata(2);
 imshow(L);
end