function hBest=ransac(locl,locr,hl,wl,hr,wr,MAX_ITER,MIN_INLIERS_FACTOR,r)

inliersBest =0;
inliers=0;
hBest=zeros(3,3);
h=zeros(3,3);
i=0;
numPoints=size(locl,1);

while i<MAX_ITER 
    i=i+1;
p = randperm(numPoints,4);

xyl=zeros(4,2);
xyr=zeros(4,2);
for j=1:4
   
xyl(j,:)=  locl(p(j),:);
xyr(j,:)=  locr(p(j),:);
end

h=homography( xyl(:,1),xyl(:,2), xyr(:,1),xyr(:,2) ,hl,wl,hr,wr );

inliers=numInliersCompute(h,locl,locr,r);

if(inliers>inliersBest)
    inliersBest=inliers;
    hBest=h;
end

if(inliersBest>MIN_INLIERS_FACTOR*numPoints)
    break;
end

end

inliers/numPoints
end

